(defun c:bancomadeira ()

; para criar os volumes que fazem o acento/pernas do banco

(setq pontos2d (getvar "osmode")) 
(setq pontos3d (getvar "3dosmode"))
(setvar "osmode" 0) ; colocar o "osmode" a 0
(setvar "3dosmode" 0) ; colocar o "3dsmode" a 0


  (If (= nil
(setq altura (getreal "indique a altura do assento do banco(em y): "))) ; pedir ao utilizador uma medida para a altura do acento do banco
(setq altura 0.5)) ; definir que, se o utilizador não indicar uma altura, esta é automaticamente 0.5
  (If (= nil
(setq comprimento (getreal "indique o comprimento do assento do banco(em x): "))) ; pedir ao utilizador uma medida para o comprimento da parte do acento do banco
(setq comprimento 0.6)) ; definir que, se o utilizador não disser o comprimento, este é automaticamente 0.6
  
(setq point (getpoint "\nSelect insertion point for the object: ")) ; pedir ao utilizador para indicar o ponto de inserção
  (command "_ucs" point "")
  
  (princ)
  (command "_pline" (list 0 0 0) (list 0 (- altura 0.1) 0) "a" (list 0.1 altura 0) "l" (list comprimento altura 0) "a" (list (+ comprimento 0.1) (- altura 0.1) 0) "l" (list (+ comprimento 0.1) 0 0) "") ; criação do "path" com uma polylinha com possibilidade de alteração de medidas pelo utilizador, para usar a mesma mais à frente com o comando _Array
  (princ)
  (setq path (entlast)) ; salvar a polylinha com o nome "path" para ser utilizada como o caminho do comando _sweep
  (command "_ucs" "3p" (list 0 0 0) (list 0 0.4 0) (list 0 0 5)) ; trocar o ucs para levantar a polylinha feita
  (princ)
  (command "_rotate" "last" "" (list 0 0 0) "90") ; levantar a polylinha com auxílio de rotação
  (princ)
  (command "_ucs" "w" "") ; para repôr o ucs
  (princ)
  (command "_ucs" point "") ; para voltar a pôr o ucs no ponto de inserção
  (princ)
  (command "_rectang" (list 0 0 0) (list 0.05 0.01 0)) ; definição da forma que vai criar o volume base para as lâminas que constituem o banco
  (princ)
  (command "_sweep" "last" "" path) ; criação do volume das lâminas
  (princ)
  (command "_array" "last" "" "r" 26 1 0.02 "") ; repetição das lâminas de forma a dar espessura ao acento/ pernas como conjunto de cheios e vazios
  (princ)
  (command "_circle" (list 0 0 0) 0.0125) ; criação de um círculo para fazer os elementos estabilizadores cilindricos tipo parafusos
  (setq circulo (entlast))
  (princ)
  (command "_ucs" "3p" (list 0 0 0) (list 0 0.4 0) (list 0 0 5)) ; trocar o ucs para levantar o circulo feita
  (princ)
  (command "_rotate" circulo "" (list 0 (- 0.0125) 0) "90") ; levantar o circulo
  (princ)
  (command "_extrude" circulo "" "0.51") ; criar o volume do elemento destabilizante em cilindro
  (setq paraf (entlast)) ; definição do volume anterior como "paraf" de parafuso
  (command "_ucs" "w" "") ; coloca o ucs no seu estado anterior
  (princ)
  (command "_ucs" point "") ; coloca o ucs no ponto de inserção
  (command "_move" paraf "" "d" (list 0 0 0.25)) ; mover o o parafuso para a altura media dos pés do banco com altura 0.5
  (princ)
  (command "_move" paraf "" "d" (list 0 0.5225 0)) ; mover o parafuso para o y que corresponde com o eixo horizontal central das pernas do banco
  (command "_move" paraf "" "d" (list 0.025 0 0)) ; mover o parafuso para o x que corresponde com o eixo vertical central das pernas do banco
  (command "_array" paraf "" "r" 1 2 (+ comprimento 0.05) "") ; faz com que cada perna tenha um parafuso nas coordenadads desejadas, ou seja, na altura média e equidistantes às laterais de cada perna
  (command "_ucs" "w" "") ; mudar o ucs para o seu estado normal (aqui não há necessidade de pôr o ucs no ponto de inserção porque já acabámos de desenhar o objeto


(setvar "osmode" pontos2d) ; repôr o osmode
(setvar "3dosmode" pontos3d) ; repôr o 3dsmode
)